
#include <stdio.h>

#define NPAIR 3

struct xy {
	float x;
	float y;
};	

struct latrow {
	float lat;
	struct xy xypair[NPAIR];
};

struct latrow allmap[] = {
{ 0,-128,   0, -95,   0,  -60, 0 },
{ 25,  8, 604, 572, 604, 1168, 562 },
{ 30,  8, 509, 571, 508, 1168, 485 },
{ 35,  8, 408, 571, 408, 1168, 384 },
{ 40,  8, 304, 571, 301, 1168, 302 },
{ 45,  8, 186, 571, 180, 1168, 187 },
{ 52,  8,   8, 571,   3, 1168,   6 },
};

int main()
{
int i1;
int i, j;
int ulrow, ulcol;
int llrow, llcol;
int urrow, urcol;
int lrrow, lrcol;
int maxrow;
float dlat, dlon;
float px, py;
float xt,xb,yt,yb;
float x,y;

maxrow = sizeof(allmap)/sizeof(struct latrow);

/* read in desired coordinate */
	while(scanf("%f %f",&dlat,&dlon) != EOF){
		/* search through the rows and columns to bracket */
		ulcol= -1;
		for(i=0;i<NPAIR -1;i++){
			if(dlon >= allmap[0].xypair[i].x && dlon <= allmap[0].xypair[i+1].x)
					ulcol = i;
		}
		ulrow = -1;
		for (j=1 ; j < maxrow -1 ;j++)
			if(dlat >= allmap[j].lat && dlat <= allmap[j+1].lat)
					ulrow = j;
		if(ulcol >= 0 && ulrow > 0){
			urrow = ulrow;
			urcol = ulcol + 1;
			llrow = ulrow + 1;
			llcol = ulcol;
			lrrow = llrow;
			lrcol = llcol +1;
		
		/*
		printf("(%d,%d) (%d,%d) (%f,%f) (%f,%f) (%f,%f) (%f,%f)\n",ulrow,ulcol,urrow,urcol,
			allmap[ulrow].lat,allmap[0].xypair[ulcol].x,allmap[urrow].lat,allmap[0].xypair[urcol].x,
			allmap[ulrow].xypair[ulcol].x,allmap[ulrow].xypair[ulcol].y,
			allmap[urrow].xypair[urcol].x,allmap[urrow].xypair[urcol].y);
		printf("(%d,%d) (%d,%d) (%f,%f) (%f,%f) (%f,%f) (%f,%f)\n",llrow,llcol,lrrow,lrcol,
			allmap[llrow].lat,allmap[0].xypair[llcol].x,allmap[lrrow].lat,allmap[0].xypair[lrcol].x,
			allmap[llrow].xypair[llcol].x,allmap[llrow].xypair[llcol].y,
			allmap[lrrow].xypair[lrcol].x,allmap[lrrow].xypair[lrcol].y);
		*/
		/* determine position factor within the grid with px, py assuming that
			the grid of lat/lon is uniform */
			px = (dlon - allmap[0].xypair[ulcol].x)/(allmap[0].xypair[urcol].x-allmap[0].xypair[ulcol].x);
			py = (dlat - allmap[ulrow].lat)/(allmap[llrow].lat -allmap[ulrow].lat);
			/*
			printf("px %f py %f\n",px,py);
			*/
			/* interpolation on x - lon */
			xt = (1. -px)*allmap[ulrow].xypair[ulcol].x + px*allmap[urrow].xypair[urcol].x;
			yt = (1. -px)*allmap[ulrow].xypair[ulcol].y + px*allmap[urrow].xypair[urcol].y;
			xb = (1. -px)*allmap[llrow].xypair[llcol].x + px*allmap[lrrow].xypair[lrcol].x;
			yb = (1. -px)*allmap[llrow].xypair[llcol].y + px*allmap[lrrow].xypair[lrcol].y;
			/* final interpolation on y -lat */
			x = (1.-py)*xt + py * xb;
			y = (1.-py)*yt + py * yb;
			fprintf(stderr,"(%f,%f) -> (%f,%f)\n",dlat,dlon,x,y);
			/*
			The coordinates were based on a 1000 x 888 map  but we will adjust by 60 percent 
			*/
	printf("<AREA SHAPE=circle HREF=\"NADSP/%2.2d.%3.3d.png\" COORDS=\"%d,%d,10 \"> \n",(int)dlat,(int)dlon,(int)(1.0*x),(int)(1.0*y));
		}
	}
}
